indexing
	descripcion: "Obtener un array ordenado que contenga todas las cadenas de caracteres que se leen de consola"
	version: "Insertar en orden. Realiza búsqueda binaria del lugar a insertar"
class BUSCAR_EN_ARRAY_Y_ELIMINAR
creation
	make
feature
	make is
	local
		a: ARRAY[STRING]
		nueva_cadena: STRING
		i: INTEGER

	do
		create a.make(1,0)

		-- Leer de consola
		from
			std_input.read_line
		until
			std_input.last_string.is_equal("")
		loop
			nueva_cadena := clone(std_input.last_string)

			a.add(nueva_cadena, su_sitio(a,nueva_cadena))

			std_input.read_line
		end

		imprimir_array(a)

		-- Leer elemento a buscar
		std_output.put_string("%NIntroduzca elemento a buscar:%N")
		std_input.read_line
		nueva_cadena := clone(std_input.last_string)

		-- Version A
		--if a.has(nueva_cadena) then
		--	a.remove(a.index_of(nueva_cadena))
		--else 
		--	std_output.put_string("%NNo se encuentra el elemento.%N")
		--end

		-- Version B
		i := a.index_of(nueva_cadena)

		if a.valid_index(i) then -- i = a.upper + 1
			a.remove(i)
		else
			std_output.put_string("%NNo se encuentra el elemento.%N")
		end


		std_output.put_new_line
		imprimir_array(a)

	end -- make

	imprimir_array(a: ARRAY[STRING]) is
	-- Imprime cada elemento del array en una línea
	local
		i : INTEGER
	do
		from
			i := a.lower
		until
			i > a.upper
		loop
			std_output.put_string(a.item(i))
			std_output.put_new_line
			i := i + 1
		end
	end --imprimir_array

	su_sitio(a: ARRAY[STRING]; cadena: STRING): INTEGER is
	-- indica la posición donde insertar el elemento dado que el array está ordenado
	local
		i, j, mitad: INTEGER
	do
			from
				j := a.lower
				i := a.upper
			until
				j > i
			loop
				mitad := (i + j) // 2
				if a.item( mitad ) > cadena then
					i := mitad - 1
				else
					j := mitad + 1
				end
			end
			Result := j
	end --su_sitio

end --class BUSCAR_EN_ARRAY_Y_ELIMINAR
