indexing
	descripcion: "Obtener un array ordenado que contenga todas las cadenas de caracteres que se leen de consola"
	version: "Insertar en orden"
class INSERTAR_ORDENADO_ARRAY
creation
	make
feature
	make is
	local
		a: ARRAY[STRING]
		nueva_cadena: STRING

	do
		create a.make(1,0)

		-- Leer de consola
		from
			std_input.read_line
		until
			std_input.last_string.is_equal("")
		loop
			nueva_cadena := clone(std_input.last_string)

			a.add(nueva_cadena, su_sitio(a,nueva_cadena))

			std_input.read_line
		end

		imprimir_array(a)

	end -- make

	imprimir_array(a: ARRAY[STRING]) is
	-- Imprime cada elemento del array en una línea
	local
		i : INTEGER
	do
		from
			i := a.lower
		until
			i > a.upper
		loop
			std_output.put_string(a.item(i))
			std_output.put_new_line
			i := i + 1
		end
	end --imprimir_array

	su_sitio(a: ARRAY[STRING]; cadena: STRING): INTEGER is
	-- indica la posición donde insertar el elemento dado que el array está ordenado
	local
		i: INTEGER
		encontrado: BOOLEAN
	do
			Result := a.upper + 1
			from
				i := a.lower -- i := 1
			until
				i > a.upper or encontrado
			loop
				if a.item(i) > cadena then
					Result := i
					encontrado := true
				else
					i := i + 1
				end
			end
	end --su_sitio

end --class INSERTAR_ORDENADO_ARRAY
