indexing
	descripcion: "Pila genérica, almacena los elementos en un array"
class PILA[G]
creation
	make
feature {NONE}
	make is
	-- se asegura de los elementos puedan ser introducidos en la pila
	-- pues se cuente con un array válido. Solo puede ser utilizado
	-- como método de creación.
	do
		create elementos.make(1,0)	
	end

feature {ANY}

	is_empty: BOOLEAN is
	-- Indica Verdadero si no hay elementos en la pila
	do
		Result := elementos.count = 0
	end

	top: G is
	-- Devuelve el último elemento almacenado en la pila
	-- Estructura LIFO (Last In First Out)
	require
		no_vacia: not is_empty
	do
		Result := elementos.last
	end

	push(e: G) is
	-- Introduce un elemento en la pila
	do
		elementos.add_last(e)	
	end

	pop is
	-- Elimina de la pila el último elemento almacenado en ella
	-- Estructura LIFO (Last In First Out)
	require
		no_vacia: not is_empty
	do
		elementos.remove(elementos.upper)
	end
feature {NONE}
	elementos: ARRAY[G] -- almacén de los elementos de la pila
end--class PILA[G]
