indexing
	descripcion: "Representa a todos los usuarios del sistema y les mantiene en un orden dado por el identificador del usuario"
class SISTEMA
creation
	make_from_file
feature
	usuarios: ARRAY[USUARIO]
feature {NONE}
	make_from_file(f: TEXT_FILE_READ) is
	-- A partir de un fichero con el formato de /etc/passwd crea un listado
	-- de los usuarios del sistema
	require
		fichero_valido: f /= Void
		fichero_conectado: f.is_connected
	local
		linea: STRING
		u: USUARIO
	do
		-- Crear el array de usuarios
		create usuarios.make(1,0)

		from
			f.read_line
		until
			f.end_of_input
		loop
			linea := clone(std_input.last_string)
			create u.make_from_string(linea)
			usuarios.add(u, su_sitio(u))
			f.read_line
		end
	end -- make_from_file

	su_sitio(u: USUARIO): INTEGER is
	-- indica la posición donde insertar el elemento dado que el array está ordenado
	local
		i, j, mitad: INTEGER
	do
			from
				j := usuarios.lower
				i := usuarios.upper
			until
				j > i
			loop
				mitad := (i + j) // 2
				if usuarios.item( mitad ).id > u.id then
					i := mitad - 1
				else
					j := mitad + 1
				end
			end
			Result := j
	end --su_sitio

feature {ANY}

	buscar_usuario(id: STRING): INTEGER is
	-- Permite realizar búsquedas más eficientes aprovechando el hecho de que el array se encuentra ordenado
	-- Si el usuario ya está se devuelve la posición en el array de usuarios
	-- Si no está el usuario se devuelve usuarios.upper + 1
	local
		i, j, mitad: INTEGER
		encontrado: BOOLEAN
	do
			Result := usuarios.upper + 1
			from
				j := usuarios.lower
				i := usuarios.upper
			until
				j > i or encontrado
			loop
				mitad := (i + j) // 2
				if usuarios.item( mitad ).id.is_equal(id) then
					encontrado := true
					Result := mitad
				elseif usuarios.item( mitad ).id > id then
					i := mitad - 1
				else
					j := mitad + 1
				end
			end
	end --buscar_usuario


end --class SISTEMA
