class MI_VOCABULARIO
creation
	make
feature
	vocablos: TABLA[CHARACTER, STRING]

	make is
	local
		palabra: STRING
		fin_de_la_entrada: BOOLEAN
		c: CHARACTER
	do
		from
			create vocablos.crea_vacia
		until
			fin_de_la_entrada
		loop		
			std_output.put_string(
		  	"Introduzca una palabra (para terminar, introduzca una línea vacía): ")
			std_input.read_line
			palabra := clone(std_input.last_string)

			fin_de_la_entrada := palabra.is_equal("")
			if not fin_de_la_entrada then
				if not es_palabra(palabra) then
					std_output.put_string("Se espera una palabra, o bien una línea vacía para terminar: ... %N")
				else
					vocablos.insertar(palabra.first, palabra)
				end -- si no era una palabra
			end --si no se ha terminado la entrada
		end -- loop

		std_output.put_string(
			"Se mostrarán todas las palabras que comienzan por el carácter: ")
		std_input.read_character
		c := std_input.last_character
		
		obtener_todas_las_palabras_que_empiezan_por(c)

		if vocablos.claves.count > 1 then
			std_output.put_string(
				"La mayor cantidad de palabras comienza por la letra...: ")

			std_output.put_character(el_mas_frecuente)
		end

		std_output.put_new_line
	end -- make
	
	es_palabra(s: STRING): BOOLEAN is
	-- indica si s es una palabra válida. Si s no está conectada
	-- devolverá false. Si está conectada devolverá verdadero si no
	-- existe ningún carácter separador en la cadena.
	do
		if s /= Void then
			Result := s.occurrences(' ') = 0 and 
				  s.occurrences('%N') = 0 and 
				  s.occurrences('	') = 0
		end
	end

	obtener_todas_las_palabras_que_empiezan_por(c: CHARACTER) is
		
			
	local
		lista: ARRAY[STRING]
		i: INTEGER
	do
		lista := vocablos.valores_con_igual_clave(c)

		from
			i := lista.lower	
		until
			i > lista.upper
		loop
			std_output.put_string(lista.item(i))
			i := i + 1

			if i <= lista.upper then
				std_output.put_string(", ")
			else 
				std_output.put_string("%N")
			end
		end
	end

	el_mas_frecuente: CHARACTER is	
	require
		vocablos.claves /= Void
		vocablos.claves.count >= 1
	local
		i, cuantos, maximo : INTEGER
		en: ARRAY[CHARACTER]	
	do
		from
			en := vocablos.claves
			i := en.lower
			cuantos := en.fast_occurrences(en.item(i)) 
			maximo := cuantos
			Result := en.item(i)
		until
			en.upper - i < maximo
		loop
			cuantos := en.fast_occurrences(en.item(i))
			if cuantos > maximo then
				maximo := cuantos
				Result := en.item(i)
			end
			i := i + 1
		end
	end

end -- class MI_VOCABULARIO
